<template>
    <div class="ois-upload-page">
        <form ref="ois-upload" id="ois-upload" class="ois-upload-form" @submit.prevent="">
            <base-field-upload-ois
                v-model="form['files[]']"
                :httpProgress="progressUpload"
                :httpSuccess="oisSuccessUploaded"
                :httpError="oisErrorUploaded"
            />
            <div class="ois-upload-page__content">
                <base-container size="small-one">
                    <h2>{{ $t('ois.upload.addOis') }}</h2>
                    <!-- Название start -->
                    <div
                        v-for="(item, key) in form.name.length"
                        :key="`name-${key}`"
                        class="ois-upload-form__flex-block default-margin-input"
                    >
                        <div class="ois-upload-form__flex-block-content">
                            <base-field-input
                                v-model="form.name[key].text"
                                :name="`name-${key}`"
                                :error="getErrorForm(`name-${key}`)"
                                class="ois-upload-form__flex-block-input input-kit--placeholder--opacity"
                                :placeholder="$t('ois.upload.name')"
                            />
                            <base-field-select
                                v-model="form.name[key].lang"
                                :list="lang"
                                class="ois-upload-form__flex-block-select"
                            />
                        </div>
                    </div>

                    <div class="ois-upload-page__add-block-wrap">
                        <div
                            class="ois-upload-page__add-block"
                            @click="addElement('name')"
                        >
                            {{ $t('ois.upload.add_lang') }}
                        </div>
                    </div>
                    <!-- Название end -->
                    <!-- Альтернативное название start -->
                    <div
                        v-for="(item, key) in form.aliases.length"
                        :key="`aliases-${key}`"
                        class="ois-upload-form__flex-block default-margin-input"
                    >
                        <div class="ois-upload-form__flex-block-content">
                            <base-field-input
                                v-model="form.aliases[key].text"
                                :name="`aliases-${key}`"
                                class="ois-upload-form__flex-block-input input-kit--placeholder--opacity"
                                :placeholder="$t('ois.upload.alt_name')"
                            />
                            <base-field-select
                                v-model="form.aliases[key].lang"
                                :list="lang"
                                class="ois-upload-form__flex-block-select"
                            />
                        </div>
                    </div>

                    <div class="ois-upload-page__add-block-wrap">
                        <div
                            class="ois-upload-page__add-block"
                            @click="addElement('aliases')"
                        >
                            {{ $t('ois.upload.add_lang') }}
                        </div>
                    </div>
                    <!-- Альтернативное название end -->
                    <!-- тип ОИС start -->
                    <base-field-select
                        v-model="form.type"
                        :list="typeOIS"
                        :error="getErrorForm('type')"
                        :dummy="$t('ois.upload.select_ois')"
                        class="default-margin-input field-select--dummy--opacity"
                    />
                    <!-- тип ОИС end -->
                    <!-- Описание start -->
                    <base-field-textarea
                        v-model="form.description"
                        :error="getErrorForm('description')"
                        name="description"
                        :placeholder="$t('ois.upload.description')"
                        class="field-textarea--placeholder--opacity default-margin-input"
                    />
                    <!-- Описание end -->
                    <!-- Изображение обложки start -->
                    <base-field-file-image
                        v-model="form.cover"
                        :maxWidth="400"
                        :headerField="$t('ois.upload.cover_img')"
                        :header="$t('ois.upload.cover')"
                        class="default-margin-input"
                    />
                    <!-- Изображение обложки end -->
                    <!-- Категории start -->
                    <base-field-tags
                        v-model="form.categories"
                        :daData="apiDaData.categories"
                        :placeholder="$t('ois.upload.category')"
                        class="default-margin-input field-tags--input--opacity"
                    />
                    <!-- Категории end -->
                    <!-- Жанры/стили start -->
                    <base-field-tags
                        v-model="form.topics"
                        :daData="apiDaData.topics"
                        :placeholder="$t('ois.upload.styles')"
                        class="default-margin-input field-tags--input--opacity"
                    />
                    <!-- Жанры/стили end -->
                    <!-- Настроение start -->
                    <base-field-tags
                        v-model="form.moods"
                        :daData="apiDaData.moods"
                        :placeholder="$t('ois.upload.mood')"
                        class="default-margin-input field-tags--input--opacity"
                    />
                    <!-- Настроение end -->
                    <!-- Теги start -->
                    <base-field-tags
                        v-model="form.tags"
                        :daData="apiDaData.tags"
                        :placeholder="$t('ois.upload.tags')"
                        class="default-margin-input field-tags--input--opacity"
                    />
                    <!-- Теги end -->
                    <!-- Ненормативная лексика start -->
                    <base-field-toggle
                        v-model="form.explicit"
                        :text="$t('ois.upload.profanity')"
                        class="default-margin-input field-toggle--opacity"
                    />
                    <!-- Ненормативная лексика end -->
                    <!-- Контент для взрослых start -->
                    <base-field-toggle
                        v-model="form.age_allowed"
                        :text="$t('ois.upload.adult')"
                        class="default-margin-input field-toggle--opacity"
                    />
                    <!-- Контент для взрослых end -->
                </base-container>

                <base-container size="small">
                    <div class="grouped-buttons ois-upload-form__grouped-buttons">
                        <base-button
                            :text="$t('button.clear')"
                            theme="clear"
                            class="ois-upload-form__clear-button"
                            @clickButton="clearForm"
                        />
                        <base-button
                            :text="$t('button.send_moderator')"
                            theme="save"
                            class="ois-upload-form__save-button"
                            @clickButton="OISUpload"
                        />
                    </div>
                </base-container>
            </div>
        </form>
    </div>
</template>

<script>
import form from 'mixins/form';
import { DA_DATA_TOPICS, DA_DATA_MOODS, DA_DATA_CATEGORIES, DA_DATA_TAGS } from 'const/apiDaData';
import { API_IP_CANDIDATES } from 'const/api';
// import { scroller } from 'vue-scrollto/src/scrollTo';
import { cloneDeep } from 'lodash';

export default {
    name: 'ois-upload',
    mixins: [form],
    default: {
        channel_id: 'media',
        'files[]': null,
        name: [
            {
                text: '',
                lang: 'En'
            }
        ],
        aliases: [
            {
                text: '',
                lang: 'Ru'
            }
        ],
        type: '',
        description: '',
        cover: null,
        categories: [],
        topics: [],
        moods: [],
        tags: [],
        explicit: false,
        age_allowed: false
    },
    data() {
        return {
            progressUpload: 0,
            oisSuccessUploaded: false,
            oisErrorUploaded: '',
            form: cloneDeep(this.$options.default),
            lang: [
                'Ru',
                'En',
                'Us'
            ],
            typeOIS: [
                'Фонограмма',
                'Музыкальное произведение',
                'Звуковой эффект',
                'Сэмпл',
                'Саундтрек к видеоряду'
            ]
        };
    },
    computed: {
        apiDaData() {
            return {
                topics: DA_DATA_TOPICS,
                moods: DA_DATA_MOODS,
                categories: DA_DATA_CATEGORIES,
                tags: DA_DATA_TAGS
            };
        }
    },
    methods: {
        addElement(name) {
            this.form[name].push({ text: '', lang: 'Ru' });
        },
        prepareData() {
            const formData = new FormData();

            for (let prop in this.form) {
                if (this.form[prop] !== null && (this.form[prop].length > 0 || typeof this.form[prop] === 'boolean' || this.form[prop] instanceof File)) {
                    switch (prop) {
                    case 'aliases':
                        this.form[prop].map(item => {
                            if (item.text) formData.append(`${prop}[${item.lang.toLowerCase()}]`, item.text);
                        });
                        break;
                    case 'explicit':
                        formData.append(prop, this.form[prop] ? 1 : 0);
                        break;
                    case 'age_allowed':
                        formData.append(prop, this.form[prop] ? 18 : 0);
                        break;
                    case 'name':
                        if (this.form[prop][0].text) formData.append(prop, this.form[prop][0].text);
                        break;
                    case 'topics':
                    case 'moods':
                    case 'categories':
                    case 'tags':
                        this.form[prop].map((item, key) => formData.append(`${prop}[${key}]`, item.id));
                        break;
                    default:
                        formData.append(prop, this.form[prop]);
                        break;
                    }
                }
            }
            return formData;
        },
        checkValideForm() {
            if (!this.form.type) {
                this.addErrorForm('type', 'Необходимо выбрать тип!');
            }

            if (!this.form.description) {
                this.addErrorForm('description', 'Заполните описание!');
            }

            this.form.name.map((item, key) => {
                if (!item.text) this.addErrorForm(`name-${key}`, 'Необходимо заполнить название!');
            });
        },
        OISUpload() {
            this.clearErrorsForm();
            this.checkValideForm();

            if (this.isValideForm) {
                const formData = this.prepareData();
                // scroller()('#ois-upload');
                const self = this;
                this.$http.post(API_IP_CANDIDATES, formData,
                    {
                        headers: {
                            'Accept': 'application/json',
                            'X-Requested-With': 'XMLHttpRequest',
                            'Content-Type': 'multipart/form-data'
                        },
                        onUploadProgress(progressEvent) {
                            self.progressUpload = parseInt(Math.round((progressEvent.loaded * 100) / progressEvent.total));
                        },
                        startRequest: false,
                        finallyRequest: false
                    })
                    .then(response => {
                        this.oisSuccessUploaded = true;
                        this.$router.push('/ois');
                    })
                    .catch(() => {
                        this.oisErrorUploaded = 'Произошла ошибка при загрузки файла.';
                    });
            }
        },
        clearForm() {
            this.form = cloneDeep(this.$options.default);
        }
    }
};
</script>

<style lang="sass">
    .ois-upload-form
        &__grouped-buttons
            margin-top: 50px

        &__flex-block
            &-content
                display: flex
                align-items: baseline
            &-input
                margin-bottom: 0
                width: 100%
            &-select
                width: 100px !important
                margin-left: 40px !important
                flex-shrink: 0 !important
            @media screen and (max-width: 480px)
                &-content
                    flex-wrap: wrap
                &-select
                    width: 100%
                    margin-left: 0
                    margin-top: 30px
        &__clear-button, &__save-button
            width: auto;
        @media screen and (max-width: 480px)
            &__clear-button, &__save-button
                width: 100%
            &__clear-button
                order: 2
                margin-top: 30px

    .ois-upload-page
        &__content
            margin: 94px 0 50px
        &__add-block-wrap
            display: flex
            justify-content: flex-end
        &__add-block
            color: #61CFFF
            text-transform: uppercase
            margin-bottom: 30px
            cursor: pointer
</style>
